#!/usr/bin/env python

import os
from wxPython.wx import *
from wxPython.html import *
import codecs
import readdic
import re
import string

projectName = "pyDic"
dicfile_path = "/usr/share/pydic/dic/engkor.dic" #FIXME

#Ʈ Ʈ
fontsl = [
			[4, 5, 6, 8, 9, 10, 12],
			[5, 6, 8, 9, 10, 12, 16],
			[6, 8, 9, 10, 12, 16, 20],
			[8, 9, 10, 12, 16, 20, 22],
			[9, 10, 12, 16, 20, 22, 26],
			[10, 12, 16, 20, 22, 26, 30],
			[12, 16, 20, 22, 26, 30, 32]
		]

#ѱ  Լ ȭ
u = lambda str="", encode="euc-kr":unicode(str, encode)

class MainWindow(wxApp):
	def OnInit(self):
		self.main_frame = wxFrame(NULL, -1, "pyDic", size=(300, 240), style=wxDEFAULT_FRAME_STYLE|wxNO_FULL_REPAINT_ON_RESIZE)

		""" о κ ߰"""
		self.wordDic = {}
		self.wordList = []
		f = self.main_frame.GetFont() #FIXME

		self.word_text = wxTextCtrl(self.main_frame, 20, "", wxPoint(-1, -1), wxSize(150, -1), style=wxTE_PROCESS_ENTER)
		self.meaning_html = wxHtmlWindow(self.main_frame, -1)
		self.meaning_html.SetFonts(f.GetFaceName(), f.GetFaceName(), fontsl[2])

		self.boxv = wxBoxSizer(wxVERTICAL)
		self.boxv.Add(self.word_text, 0, wxEXPAND)
		self.boxv.Add(self.meaning_html, 1, wxEXPAND)

		self.main_frame.sizer = self.boxv
		self.main_frame.SetAutoLayout(True)
		self.main_frame.SetSizer(self.main_frame.sizer)
		#self.sizer.Fit(self)

		#Ʈ ̺Ʈ
		EVT_TEXT(self.main_frame, 20, self.OnText)
		EVT_TEXT_ENTER(self.main_frame, 20, self.OnTextEnter)

		self.dicfile = self.openDic(dicfile_path)
		self.word_text.SetFocus()

		return True

	def openDic(self, dicpath):
		dicfile = open(dicpath, "r")

		if readdic.verifyDic(dicfile, "LDIC"):
			pass
		else:
			print u("̰ ùٸ   ƴմϴ.")
			exit

		list, l_offset_s, l_offset_e, mean, m_offset_s, m_offset_e, fnt, f_offset_s, f_offset_e = readdic.readHeader(dicfile, "cllcllcll")
		self.wordDic = readdic.makeWordlist(0, dicfile, l_offset_e)

		self.m_offset_s = m_offset_s

		for word in self.wordDic.keys():
			self.wordList.append(word)

		return dicfile

	def OnText(self, e):
		word = self.word_text.GetValue()
		self.search(word)
	
	def OnTextEnter(self, e):
		self.word_text.SetSelection(-1, -1)

	def search(self, word):
		try:
			meaning = readdic.searchWord(self.dicfile, self.wordDic[word], self.m_offset_s)
			temp = string.replace(meaning, "./font/", "/usr/share/pydic/font/");
			self.meaning_html.SetPage(temp)
		except:
			pass

def Main():
	app = MainWindow()
	app.main_frame.Show(True)
	app.MainLoop()
